<?
/******************************************************************************\
 *                       MSSQL Database Thread Class                          *
 ******************************************************************************
 * This is MSSQL extender for basic SQLDB class.                              *
 ******************************************************************************
 * Written by Vladimir Sibirov a.k.a. Trustmaster.                            *
\******************************************************************************/

class MSSQL extends SQLDB
{

        // Constructor
        function MSSQL($host = null, $user = null, $pass = null, $name = null)
        {
                parent::SQLDB($host, $user, $pass, $name);
                $this->base = mssql_connect($this->host, $this->user, $this->pass)
                or die('MySQL Error: Couldn\'t connect to database server.');
                mssql_select_db($this->name, $this->base)
                or die('MySQL Error: Couldn\'t select the database.');
        }

        // Runs SQL query
        function Query($query)
        {
                parent::Query($query);
                $this->result = @mssql_query($query, $this->base);
        }

        // Returns number of affected rows
        function Affected()
        {
                return @mssql_rows_affected($this->base);
        }

        // Returns last error string
        function Error()
        {
                return @mssql_get_last_message($this->base);
        }

        // Returns last error number
        function Errno()
        {
                return '';
        }


        // Closes connection
        function Close()
        {
                parent::Close();
                return @mssql_close($this->base);
        }

        // Returns number of rows in result set
        function NumRows()
        {
                return @mssql_num_rows($this->result);
        }

        // Returns single field from result set
        function Field($query = '')
        {
                parent::Field($query);
                $row = @mssql_fetch_row($this->result);
                return $row[0];
        }

        // Returns single row from result set
        function Row($query = '')
        {
                parent::Row($query);
                return @mssql_fetch_row($this->result);
        }

        // Return result set as array of rows
        function RowTable($query = '')
        {
                parent::RowTable($query);
                $i = 0;
                while($r_array = @mssql_fetch_row($this->result))
                {
                        $my_array[$i] = $r_array;
                        $i++;
                }
                return $my_array;
        }

        // Returns associative array from result set
        function AssocArray($query = '')
        {
                parent::AssocArray($query);
                return @mssql_fetch_array($this->result);
        }

        // Returns result set as array of named arrays
        function ArrayTable($query = '')
        {
                parent::ArrayTable($query);
                $i = 0;
                while($r_array = @mssql_fetch_array($this->result))
                {
                        $my_array[$i] = $r_array;
                        $i++;
                }
                return $my_array;
        }

        // Frees result set
        function Free()
        {
                if($this->result) @mssql_free_result($this->result);
        }
}
?>