<?
/******************************************************************************\
 *                      PostgreSQL Database Thread Class                      *
 ******************************************************************************
 * This is PostgreSQL extender for basic SQLDB class.                         *
 ******************************************************************************
 * Written by Vladimir Sibirov a.k.a. Trustmaster.                            *
\******************************************************************************/

class PgSQL extends SQLDB
{

        // Constructor
        function PgSQL($host = null, $user = null, $pass = null, $name = null)
        {
                parent::SQLDB($host, $user, $pass, $name);
                $connect_str = 'user='.$this->user.' password='.$this->pass.' host='.$this->host.' dbname='.$this->name;
                $this->base = pg_connect($connect_str);
                or die('PostgreSQL Error: Couldn\'t connect to database server.');
        }

        // Runs SQL query
        function Query($query)
        {
                parent::Query($query);
                $this->result = @pg_query($this->base, $query);
        }

        // Returns number of affected rows
        function Affected()
        {
                return @pg_affected_rows($this->result);
        }

        // Returns last error string
        function Error()
        {
                return @pg_last_error($this->base);
        }

        // Returns last error number
        function Errno()
        {
                return '';
        }


        // Closes connection
        function Close()
        {
                parent::Close();
                return @pg_close($this->base);
        }

        // Returns number of rows in result set
        function NumRows()
        {
                return @pg_num_rows($this->result);
        }

        // Returns single field from result set
        function Field($query = '')
        {
                parent::Field($query);
                $row = @pg_fetch_row($this->result);
                return $row[0];
        }

        // Returns single row from result set
        function Row($query = '')
        {
                parent::Row($query);
                return @pg_fetch_row($this->result);
        }

        // Return result set as array of rows
        function RowTable($query = '')
        {
                parent::RowTable($query);
                $i = 0;
                while($r_array = @pg_fetch_row($this->result))
                {
                        $my_array[$i] = $r_array;
                        $i++;
                }
                return $my_array;
        }

        // Returns associative array from result set
        function AssocArray($query = '')
        {
                parent::AssocArray($query);
                return @pg_fetch_array($this->result);
        }

        // Returns result set as array of named arrays
        function ArrayTable($query = '')
        {
                parent::ArrayTable($query);
                $i = 0;
                while($r_array = @pg_fetch_array($this->result))
                {
                        $my_array[$i] = $r_array;
                        $i++;
                }
                return $my_array;
        }

        // Frees result set
        function Free()
        {
                if($this->result) @pg_free_result($this->result);
        }
}
?>